import React from "react";
import {Grid} from "@material-ui/core";

export type PopupGridItem = {
    key: string;
    value?: string | number;
    unit?: string;
    textColor?: string;
    fullWidth?: boolean;
};
type PopupGridProps = {
    items: PopupGridItem[];
}
type PopupGridState = {}

export class PopupGrid extends React.Component<PopupGridProps, PopupGridState> {
    render() {
        return (
            <Grid container spacing={3}>
                {this.props.items.map(({key, value, unit, textColor, fullWidth}) => {
                        if (value === undefined || value === null)
                            return null;
                        return ([
                            <Grid item key={`key-${key}`} xs={2} style={{
                                color: textColor || "unset",
                                textAlign: "right",
                                fontWeight: "bold"
                            }}>
                                {key}
                            </Grid>,
                            <Grid item key={`value-${value}`} xs={fullWidth ? 10 : 4} style={{
                                color: textColor || "unset",
                            }}>
                                <span>{value}</span>
                                {unit ? <span style={{marginLeft: 4}}>{unit}</span> : null}
                            </Grid>
                        ]);
                    }
                )}
            </Grid>
        );
    }
}
